=begin
#Platform external API.

#Documentation of our Platform external API.

OpenAPI spec version: 1.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 3.0.34
=end

module Shippo
  class CustomsItemsApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Create a new customs item
    # Creates a new customs item object
    # @param merchant_id description: Object ID of the merchant
    # @param [Hash] opts the optional parameters
    # @option opts [Item] :body CustomsItem details.
    # @option opts [String] :shippo_api_version description: String used to pick a non-default api version to use
    # @return [CustomsItem]
    def create_customs_item(merchant_id, opts = {})
      data, _status_code, _headers = create_customs_item_with_http_info(merchant_id, opts)
      data
    end

    # Create a new customs item
    # Creates a new customs item object
    # @param merchant_id description: Object ID of the merchant
    # @param [Hash] opts the optional parameters
    # @option opts [Item] :body CustomsItem details.
    # @option opts [String] :shippo_api_version description: String used to pick a non-default api version to use
    # @return [Array<(CustomsItem, Integer, Hash)>] CustomsItem data, response status code and response headers
    def create_customs_item_with_http_info(merchant_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: CustomsItemsApi.create_customs_item ...'
      end
      # verify the required parameter 'merchant_id' is set
      if @api_client.config.client_side_validation && merchant_id.nil?
        fail ArgumentError, "Missing the required parameter 'merchant_id' when calling CustomsItemsApi.create_customs_item"
      end
      # resource path
      local_var_path = '/merchants/{MerchantId}/customs/items/'.sub('{' + 'MerchantId' + '}', merchant_id.to_s)

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])
      header_params[:'SHIPPO-API-VERSION'] = opts[:'shippo_api_version'] if !opts[:'shippo_api_version'].nil?

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(opts[:'body']) 

      return_type = opts[:return_type] || 'CustomsItem' 

      auth_names = opts[:auth_names] || ['APIKeyHeader']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: CustomsItemsApi#create_customs_item\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # List all customs items
    # List all customs items objects
    # @param merchant_id description: Object ID of the merchant
    # @param [Hash] opts the optional parameters
    # @option opts [String] :shippo_api_version description: String used to pick a non-default api version to use
    # @option opts [Integer] :page description: The page number you want to select (default to 1)
    # @option opts [Integer] :results description: The number of results to return per page (max 100) (default to 25)
    # @return [PaginatedCustomsItemsResponse]
    def list_customs_items(merchant_id, opts = {})
      data, _status_code, _headers = list_customs_items_with_http_info(merchant_id, opts)
      data
    end

    # List all customs items
    # List all customs items objects
    # @param merchant_id description: Object ID of the merchant
    # @param [Hash] opts the optional parameters
    # @option opts [String] :shippo_api_version description: String used to pick a non-default api version to use
    # @option opts [Integer] :page description: The page number you want to select
    # @option opts [Integer] :results description: The number of results to return per page (max 100)
    # @return [Array<(PaginatedCustomsItemsResponse, Integer, Hash)>] PaginatedCustomsItemsResponse data, response status code and response headers
    def list_customs_items_with_http_info(merchant_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: CustomsItemsApi.list_customs_items ...'
      end
      # verify the required parameter 'merchant_id' is set
      if @api_client.config.client_side_validation && merchant_id.nil?
        fail ArgumentError, "Missing the required parameter 'merchant_id' when calling CustomsItemsApi.list_customs_items"
      end
      # resource path
      local_var_path = '/merchants/{MerchantId}/customs/items/'.sub('{' + 'MerchantId' + '}', merchant_id.to_s)

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'page'] = opts[:'page'] if !opts[:'page'].nil?
      query_params[:'results'] = opts[:'results'] if !opts[:'results'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      header_params[:'SHIPPO-API-VERSION'] = opts[:'shippo_api_version'] if !opts[:'shippo_api_version'].nil?

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      return_type = opts[:return_type] || 'PaginatedCustomsItemsResponse' 

      auth_names = opts[:auth_names] || ['APIKeyHeader']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: CustomsItemsApi#list_customs_items\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Retrieve a customs item
    # Retrieve an existing customs item by object id
    # @param customs_item_id description: Object ID of the customs item
    # @param merchant_id description: Object ID of the merchant
    # @param [Hash] opts the optional parameters
    # @option opts [String] :shippo_api_version description: String used to pick a non-default api version to use
    # @option opts [Integer] :page description: The page number you want to select (default to 1)
    # @return [CustomsItem]
    def get_customs_item(customs_item_id, merchant_id, opts = {})
      data, _status_code, _headers = get_customs_item_with_http_info(customs_item_id, merchant_id, opts)
      data
    end

    # Retrieve a customs item
    # Retrieve an existing customs item by object id
    # @param customs_item_id description: Object ID of the customs item
    # @param merchant_id description: Object ID of the merchant
    # @param [Hash] opts the optional parameters
    # @option opts [String] :shippo_api_version description: String used to pick a non-default api version to use
    # @option opts [Integer] :page description: The page number you want to select
    # @return [Array<(CustomsItem, Integer, Hash)>] CustomsItem data, response status code and response headers
    def get_customs_item_with_http_info(customs_item_id, merchant_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: CustomsItemsApi.get_customs_item ...'
      end
      # verify the required parameter 'customs_item_id' is set
      if @api_client.config.client_side_validation && customs_item_id.nil?
        fail ArgumentError, "Missing the required parameter 'customs_item_id' when calling CustomsItemsApi.get_customs_item"
      end
      # verify the required parameter 'merchant_id' is set
      if @api_client.config.client_side_validation && merchant_id.nil?
        fail ArgumentError, "Missing the required parameter 'merchant_id' when calling CustomsItemsApi.get_customs_item"
      end
      # resource path
      local_var_path = '/merchants/{MerchantId}/customs/items/{CustomsItemId}/'.sub('{' + 'CustomsItemId' + '}', customs_item_id.to_s).sub('{' + 'MerchantId' + '}', merchant_id.to_s)

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'page'] = opts[:'page'] if !opts[:'page'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      header_params[:'SHIPPO-API-VERSION'] = opts[:'shippo_api_version'] if !opts[:'shippo_api_version'].nil?

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      return_type = opts[:return_type] || 'CustomsItem' 

      auth_names = opts[:auth_names] || ['APIKeyHeader']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: CustomsItemsApi#get_customs_item\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
